<?php

function __input_filter()
{
	// unset global variables from register_globals.
	if ( ini_get( 'register_globals' ) ) {
		if ( isset( $_REQUEST['GLOBALS'] ) ) {
			trigger_error( 'GLOBALS overwrite attempt detected', E_USER_ERROR );
		}
		$no_unset = array(
		   	'GLOBALS'  => '', '_GET'    => '', '_POST' => '', '_COOKIE' => '',
			'_REQUEST' => '', '_SERVER' => '', '_ENV'  => '', '_FILES'  => ''
	   	);
		$input = array_merge(
		   	$_GET, $_POST, $_COOKIE, $_SERVER, $_ENV, $_FILES,
			isset( $_SESSION ) ? (array)$_SESSION : array()
	   	);
		foreach ( array_keys( $input ) as $k ) {
			if ( ! isset( $no_unset[$k] ) && isset( $GLOBALS[$k] ) ) {
				unset( $GLOBALS[$k] );
			}
		}
	}
	// unset unused global variables (e.g. $HTTP_*_VARS).
	foreach ( array_keys( $GLOBALS ) as $k ) {
		if ( substr( $k, 0, 5 ) === 'HTTP_' ) {
			unset( $GLOBALS[$k] );
		}
	}

	// strip slashes if magic_quotes_gpc = On.
	if ( get_magic_quotes_gpc() ) {
		function __stripslashes_r( $a )
		{
			if ( is_array( $a ) ) {
				return array_map( __FUNCTION__, $a );
			}
			return stripslashes( $a );
	   	}
		if ( $_SERVER  ) { $_SERVER  = __stripslashes_r( $_SERVER  ); }
		if ( $_GET     ) { $_GET     = __stripslashes_r( $_GET     ); }
		if ( $_POST    ) { $_POST    = __stripslashes_r( $_POST    ); }
		if ( $_COOKIE  ) { $_COOKIE  = __stripslashes_r( $_COOKIE  ); }
		if ( $_REQUEST ) { $_REQUEST = __stripslashes_r( $_REQUEST ); }
	}

	// strip null byte character and unify line feed("\n").
	function __unify_filter( $a )
	{
		if ( is_array( $a ) ) {
			return array_map( __FUNCTION__, $a );
		}
		return str_replace( "\0", "",
			strtr( str_replace( "\x0D\x0A", "\n", $a ), "\x0D\x0A", "\n\n" )
	   	);
	}

	// check input string encoding
	function __check_encoding( $val, $key, $encoding )
	{
		if ( is_array( $val ) ) {
			array_walk( $val, __FUNCTION__, $encoding );
		}
		else if ( (string)$val !== mb_convert_encoding( $val, $encoding, $encoding ) ) {
			trigger_error(
				htmlspecialchars( 'Invalid Encoding : key=[' . $key . '], val=[' . $val . ']', ENT_QUOTES, $encoding ),
				E_USER_ERROR
			);
			exit;
		}
		if ( (string)$key !== mb_convert_encoding( $key, $encoding, $encoding ) ) {
			trigger_error(
				htmlspecialchars( 'Invalid Encoding : key=[' . $key . '], val=[' . $val . ']', ENT_QUOTES, $encoding ),
				E_USER_ERROR
			);
			exit;
		}
	}
	if ( $_GET     ) { array_walk( $_GET     = __unify_filter( $_GET     ), '__check_encoding', 'UTF-8' ); }
	if ( $_POST    ) { array_walk( $_POST    = __unify_filter( $_POST    ), '__check_encoding', 'UTF-8' ); }
	if ( $_COOKIE  ) { array_walk( $_COOKIE  = __unify_filter( $_COOKIE  ), '__check_encoding', 'UTF-8' ); }
	if ( $_REQUEST ) { array_walk( $_REQUEST = __unify_filter( $_REQUEST ), '__check_encoding', 'UTF-8' ); }
	if ( $_SERVER  ) { array_walk( $_SERVER  = __unify_filter( $_SERVER  ), '__check_encoding', 'UTF-8' ); }
	if ( $_ENV     ) { $_ENV     = __unify_filter( $_ENV     ); }
	if ( $_FILES   ) { $_FILES   = __unify_filter( $_FILES   ); }
}

// execute filter
__input_filter();
