<?php

class View
{
	var $table;

	function View()
	{
		$this->table = array();
	}

	function addItems( $uris = '' )
	{
		$get =& Request::getInstance( '_GET' );

		$visit = FALSE;
		$limit = $get->get( 'lim' );
		if ( PHP_SAPI !== 'cli' ) {
			$conf =& Config::getInstance();
			if ( $limit === FALSE ) {
				$limit = $conf->get( 'lim' );
			}
			if ( $conf->isAuth() ) {
				if ( $get->is_set( 'vis' ) ) {
					$visit = $get->get( 'vis' );
				}
				else {
					$visit = $conf->get( 'vis' );
				}
			}
		}
		$get->set( 'vis', $visit );
		$get->set( 'lim', $limit );

		$reader =& Data::getReader( SAVE_HANDLE );
		$this->table = $reader->getItems( $uris );

		return (bool)$this->table;
	}

	function display( $type = '' )
	{
		$data =& $this->table;

		if ( PHP_SAPI === 'cli' ) {
			include( VIEW_DIR . 'view_cli.tpl.php' );
			return;
		}
		if ( $type === 'rss' ) {
			include( VIEW_DIR . 'view_rss.tpl.php' );
			return;
		}
		// display header and main view
		$get  =& Request::getInstance( '_GET' );
		$conf =& Config::getInstance();
		$page_title = $conf->get( 'title', TOOL_NAME );

		// get message if set
		$message = '';
		$mid = $get->get( 'mid' );
		if ( $mid ) {
			if ( $conf->get( 'mid' ) === $mid ) {
				$message = $conf->get( 'message' );
			}
			$get->delete( 'mid' );
		}
		$auth      = $conf->isAuth();
		$cnt       = $conf->get( 'count' );
		$mess_lang = $conf->get( 'message_lang' );
		$uniq_id   = $conf->get( 'uniq_id', '' );

		$css = 'css/' . $conf->get( 'css' ) . '.css';
		if ( ! is_readable( SELF_DIR . $css ) ) {
			$css = 'css/default.css';
		}
		$view_file1 = VIEW_DIR . 'view_' . $type . '.tpl.php';
		$view_file2 = VIEW_DIR . $mess_lang . '/view_' . $type . '.tpl.php';
		if ( ! is_readable( $view_file1 ) || ! is_readable( $view_file2 ) ) {
			$view_file1 = 'view_default.tpl.php';
			$view_file2 = 'ja/view_default.tpl.php';
		}
		include( VIEW_DIR . 'parts_header.tpl.php' );
		include( $view_file1 );
		include( $view_file2 );
		include( VIEW_DIR . 'parts_footer.tpl.php' );
	}
}

function p( $str )
{
	echo htmlspecialchars( (string)$str, ENT_QUOTES, 'UTF-8' );
}

function u( $str )
{
	return urlencode( $str );
}

function br_p( $str )
{
	echo nl2br( h( $str ) );
}

function p_if( $cond, $str, $htmlflag = FALSE )
{
	if ( $cond ) {
		if ( $htmlflag === TRUE ) {
			echo $str;
		}
		else {
			p( $str );
		}
   	}
}

function p_ex( $str )
{
	echo nl2br(
		strtr(
			preg_replace( '/&(?!#\d+;|\w+;)/u', '&amp;', $str ),
			array(
				'>' => '&gt;',
				'<' => '&lt;',
				'"' => '&quot;',
				"'" => '&#39;'
			)
		)
	);
}
