<?php if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; } ?>
<h1><?php p( $page_title ) ?> ステータス一覧</h1>

<div class="main">

<div class="menu">
<h2>メニュー</h2>
<a href="<?php p( $top_page    ) ?>">一覧に戻る</a>
<a href="<?php p( $config_page ) ?>">設定変更</a>
<a class="selectconf" href="<?php p( $status_page ) ?>">ステータス一覧</a>
<a href="<?php p( $filter_page ) ?>">フィルタ編集</a>
<div class="checkdate">最終チェック日時: <span class="date"><?php p( $last ) ?></span></div>
</div>

<div class="list">

<?php if ( $items ) : ?>
<table class="filter_table" summary="ステータスコード表示">
<caption>アイテムステータス一覧</caption>
<thead>
 <th>ステータスコード</th>
 <th>設定画面へのリンク</th>
 <th>チェック日時</th>
 <th>更新日時</th>
</thead>
<tbody>
<?php 	foreach ( $items as $item ) : ?>
<tr>
 <td><code class="opt">
<?php if ( $item['stat'] === 'OK' || $item['stat'] === 'Not Modified' ) : ?><?php p( $item['stat'] ) ?>
<?php else: ?><strong><?php p( $item['stat'] ) ?></strong>
<?php endif ?>
</code></td>
 <td><a class="conf" title="<?php p( $item['title'] ) ?> 設定" href="<?php p( $item['uri'] ) ?>"><?php p( $item['title'] ) ?></a></td>
 <td><span class="date"><?php p( $item['check'] ) ?></span></td>
 <td><span class="date"><?php p( $item['date']  ) ?></span></td>
</tr>
<?php 	endforeach ?>
</table>
<?php else : ?>
<div class="info">項目がありません。</div>
<?php endif ?>

</div>
</div>
